#
# language_tui.py: text mode language selection dialog
#
# text mode mouse configuration screen
#
# Copyright 2002 Red Hat, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU Library Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

from snack import *
from rhpl.translate import _, textdomain_codeset
import os
import locale
import language_backend

locale.setlocale(locale.LC_ALL, "")
textdomain_codeset("redhat-config-language", locale.nl_langinfo(locale.CODESET))

languageBackend = language_backend.LanguageBackend()

class LanguageWindow:
    def __call__(self, screen):

        defaultLang, self.installedLangs = languageBackend.getInstalledLangs()
        self.originalLang = defaultLang

        bb = ButtonBar(screen, [_("OK"), _("Cancel")])
        textBox = TextboxReflowed(40, 
                _("Select the language for the system."))
        list = Listbox(8, scroll = 1, returnExit = 0)


        lines = languageBackend.readTable()

#        if self.orginalLang == None:
#            list.append('English (USA)', 0)

        for line in lines:
            tokens = string.split(line)

            if self.installedLangs == None:
                name = ""
                for token in tokens[3:]:
                    name = name + " " + token
                list.append(name, tokens[0])

#            else:
#                key = 0
#                for lang in self.installedLangs:
#                    list.append(lang, key)
#                    key = key + 1

        list.setCurrent(defaultLang)

        g = GridFormHelp(screen, _("Language Selection"), "kbdtype", 1, 4)
        g.add(textBox, 0, 0)
        g.add(list, 0, 1, padding = (0, 1, 0, 1))
        g.add(bb, 0, 3, growx = 1)

        rc = g.runOnce()

        button = bb.buttonPressed(rc)

        if button == "cancel":
            return -1

        choice = list.current()

#        mouse.set(mice[choice], emulate)

#        oldDev = mouse.getDevice()
#        if (oldDev):
#            newDev = mouse.available()[mice[choice]][2]
#            if ((oldDev[0:4] == "ttyS" and newDev[0:4] == "ttyS") or
#                (oldDev == newDev)):
#                pass
#            else:
#                mouse.setDevice(newDev)
#
#        return mouse

class childWindow:
    def __init__(self):
        screen = SnackScreen()
	screen.drawRootText (0, 0, "redhat-config-language - (C) 2002 Red Hat, Inc.");

        DONE = 0

        while not DONE:

            rc = LanguageWindow()(screen)
            if rc == -1:
                screen.finish()
                DONE = 1
            else:
                screen.finish()
                self.runConfig(rc)
                DONE = 1
                
    def runConfig(self, rc):
        pass
